!-----------------------------------------------------------------------------
!
! CAT_DEL (Catchment Delineation)
!
! The CAT_DEL ensure the delineation of an upslope area defined the i,j of the 
! outlet cell
!
!-----------------------------------------------------------------------------

subroutine cat_del_sr

use mpar
use mbbio

implicit none

integer(kind=ISP) i,j,i_basin,n_rec,nodata,n_o_quota
integer(kind=ISP) i_basin_chiusura,ht,jr,mask
integer(kind=ISP) ii,jj,ii_basin,cell_out,cells_out,outlet_cell
integer(kind=ISP) p_inflow,p_outflow_1_ciijj,p_outflow_2_ciijj

integer(kind=ISP),allocatable :: idtm(:,:)

integer(kind=IEP) :: idtm_max,idtm_min
integer(kind=ISP) :: ic
character(len=32) :: dtmfile

call rparfile('hap.in')

allocate(idtm(N,M)) 

open(16,file='qoi',access='direct',status='unknown',form='unformatted',recl=4)

read(16,rec=N_celle+1) i_basin_chiusura

cells_out=-9999
outlet_cell=1
nodata=-9999

i_basin=(i_outc+1-1)*M+j_outc+1

cell_out=0
do n_o_quota=N_celle,1,-1
   read(16,rec=n_o_quota+1) i_basin   
   jr=mod(i_basin,M)
   if (jr.ne.0) then
      j=jr
      i=(i_basin-j)/M+1
   else
      j=M
      i=i_basin/M
   end if
   if (dtm_index_pr(i_basin) == 0) then      	  
	  idtm(i,j)=nodata
   else
  	  idtm(i,j)=cells_out
      if (i == (i_outc+1) .and.j == (j_outc+1)) then
	     cell_out=n_o_quota  
             idtm(i,j)=outlet_cell
      end if
   end if 
end do
if (cell_out /= 0) then  
  do n_o_quota=cell_out+1,1,-1   
     read(16,rec=n_o_quota) i_basin
	 jr=mod(i_basin,M)
     if (jr.ne.0) then
        j=jr
        i=(i_basin-j)/M+1
     else
        j=M
        i=i_basin/M
     end if
	 if (idtm(i,j) == cells_out) cycle  ! vuol dire che la cella corrente non appartiene al bacino	che si vuole delineare
     do ii=i-1,i+1
        do jj=j-1,j+1
          p_outflow_1_ciijj=0
          p_outflow_2_ciijj=0
          if (ii.eq.0.or.ii.eq.N+1) cycle
          if (jj.eq.0.or.jj.eq.M+1) cycle
          ii_basin=(ii-1)*M+jj
          if (dtm_index_pr(ii_basin) == 0) cycle
          p_outflow_1_ciijj=dtm_p_outflow_1(ii_basin)*dtm_w_1(ii_basin)
          p_outflow_2_ciijj=dtm_p_outflow_2(ii_basin)*dtm_w_2(ii_basin)
          p_inflow=3*(ii-i)+(jj-j)+5
          if (p_inflow+p_outflow_1_ciijj.eq.10) then
             idtm(ii,jj)=1
          end if
          if (p_inflow+p_outflow_2_ciijj.eq.10) then
             idtm(ii,jj)=1
          end if
        end do
     end do	 
  end do  !do n_o_quota=cell_out+1,1,-1 
end if ! (cell_out /= 0) then

do i=1,N
   do j=1,M
      i_basin=(i-1)*M+j
      if (dtm_index_pr(i_basin) == 0) idtm(i,j)=int(nodata)
   end do
end do   

do i=1,N
   do j=1,M
      i_basin=(i-1)*M+j
      mask = idtm(i,j)
      call set_mask(i_basin,mask)
   end do
end do 

end subroutine cat_del_sr
