% Processes vertical profile (VP) output and creates graphs

vp = fopen('output-Picard/vp','r');

% Read in the file
a=0;  
b=0; 
c=0; 
d=0;
e=0;
linesinvp=0;
nstr=0;
numvp=0;
nvp=0;
nprt=0;
SURFACENODE=[];
VP=[];
FILENAME=[];
TIME=[];
while (a~=(-1))                  % Find out number of node layers (nstr),
      a = fgetl(vp);             % number of surface nodes for vertical profile output (numvp)
      linesinvp = linesinvp + 1; % and number of time values for detailed nodal output (nprt)
      if (a~=(-1))               % Loops through until a=-1 end of file
      b = double(a);
      end
      if b(1:5)==[32 83 85 82 70] % b(1:5)=' SURF'
         nvp = nvp+1;     
      end
      if b(29:33)==[78 83 84 69 80] % b(29:33)='NSTEP'
         nprt = nprt+1;
      end 
end
   linesinvp = linesinvp -1;
   nstr = (linesinvp-(2*nvp)-nprt)/nvp;
   numvp = nvp/nprt;
   frewind(vp);
for c=1:nprt % Read data
    time = fscanf(vp,'%*g %g');
    TIME = [TIME;time];
    fgets(vp);
    for d=1:numvp
        surfacenode = fscanf(vp,'%*s %*s %*s %u',1);
        SURFACENODE = [SURFACENODE;surfacenode];  % SURFACENODE contains
        fgets(vp);                                % surfacenodes for verticale    
        fgets(vp);                                % profile output
        Vp = fscanf(vp,'%g',[4,nstr]);
        Vp = Vp';
        VP = [VP;Vp];
        fgets(vp);
    end
end
%close('all');
% Create different linestyles, don't use nprt > 16
LINESTYLE(1:8,:) = ['k-+';'k-o';'k-*';'k-x';'k-^';'k-v';'k->';'k-<'];
LINESTYLE(9:16,:) = ['k:+';'k:o';'k:*';'k:x';'k:^';'k:v';'k:>';'k:<'];
TIME=TIME./86400;
TIME = round(TIME);
TIME = num2str(TIME,7);
TIME(1:nprt,9)=' ';
TIME=strcat(TIME,' days');
% Plot the graphs
for a=1:nprt
    for b=0:numvp-1
        c=b*nstr+1+e;
        d=(b+1)*nstr+e;      
        figure(b+1)
        hold on
        plot(VP(c:d,2),VP(c:d,1),LINESTYLE(a,:))
%         plot(VP(c:d,3),VP(c:d,1),LINESTYLE(a,:))
%         legend(TIME,a);
    end
    e=d;
end
hold on

% Set titles and lay-out
for a=1:numvp
    figure(a)
    xlabel('Pressure Head (m)')
%     xlabel('Water Saturation (m)')
    ylabel('Z (m)')
    title(['Vertical profile at surface node ',num2str(SURFACENODE(a))])
%     FILENAME = ['d:\my local documents\daufin\cathy\i-o\modelapr01\8month1993-10daysic\graphs\graphvp',num2str(SURFACENODE(a))];
%     print('-deps','-r200',FILENAME);
    
end
 
